=== debian/changelog ===
ares (147+dfsg-2) unstable; urgency=medium

  [ Alexandre Detiste ]
  * Team upload.
  * add debian/salsa-ci.yml
  * wrap-and-sort -ast
  * drop duplicated debhelper build-dep
  * drop "Rules-Requires-Root: no": it is the default now

  [ Christopher Obbard ]
  * d/control: Use gtksourceview4 instead of gtksourceview3 (Closes: #1079407)

  [ David James ]
  * Expand man page

 -- Christopher Obbard <obbardc@debian.org>  Wed, 28 Jan 2026 17:46:54 +0000

ares (147+dfsg-1) unstable; urgency=medium

  * Updated d/watch to version 5
  * Updated SDL dependency to libsdl3-dev
  * Converted d/patches to use new CMake build system
  * updated debian/* to use CMake
  * Bump package standards version to 4.7.3

 -- David James <davidjamescastor215@proton.me>  Mon, 05 Jan 2026 19:27:49 +0000
