=== debian/control ===
Source: ares
Section: otherosfs
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 David James <davidjamescastor215@proton.me>,
 Tobias Hansen <thansen@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libao-dev,
 libasound2-dev [linux-any],
 libchdr-dev,
 libgtk-3-dev,
 libgtksourceview-4-dev,
 libopenal-dev,
 libpulse-dev,
 libsdl3-dev,
 libudev-dev [linux-any],
 libxv-dev,
 pkgconf,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/games-team/ares
Vcs-Git: https://salsa.debian.org/games-team/ares.git
Homepage: https://ares-emu.net

Package: ares
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 nes-emulator,
Description: Accurate multi-system emulator
 ares is an emulator for systems from Atari, Nintendo, Sega, Sony, NEC, SNK,
 Microsoft, Coleco, Bandai and Benesse. It is a descendent of higan and bsnes
 and focuses on accuracy and preservation. The SNES emulation is especially
 complete and polished.
