=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/\+dfsg\d*//
Owner: ares-emulator
Project: ares
Repack: yes
Repacksuffix: +dfsg
